function varargout = interface(varargin)
% INTERFACE MATLAB code for interface.fig
%      INTERFACE, by itself, creates a new INTERFACE or raises the existing
%      singleton*.
%
%      H = INTERFACE returns the handle to a new INTERFACE or the handle to
%      the existing singleton*.
%
%      INTERFACE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in INTERFACE.M with the given input arguments.
%
%      INTERFACE('Property','Value',...) creates a new INTERFACE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before interface_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to interface_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help interface

% Last Modified by GUIDE v2.5 28-Jan-2017 02:15:06

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @interface_OpeningFcn, ...
                   'gui_OutputFcn',  @interface_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before interface is made visible.
function interface_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to interface (see VARARGIN)

% Choose default command line output for interface
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

%set default path to current folder (for creating folders)
set(handles.path, 'string', pwd);

%Disable tab 2 and 3 and set them to invisible
set(handles.panel2,'Visible','off')
set(handles.panel3,'Visible','off')
set(handles.tab1, 'Enable', 'off')

validate (handles)

%Disable Continue button in license tab
%set(handles.panel0,'Enable','off');
%array that will hold info

% UIWAIT makes interface wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = interface_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in tab2.
function tab2_Callback(hObject, eventdata, handles)
% hObject    handle to tab2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.panel2,'Visible','on')
set(handles.panel3,'Visible','off')
set(handles.tab1, 'Enable', 'on')
set(handles.tab2, 'Enable', 'off')
set(handles.tab3, 'Enable', 'on')
% Hint: get(hObject,'Value') returns toggle state of tab2


% --- Executes on button press in tab1.
function tab1_Callback(hObject, eventdata, handles)
% hObject    handle to tab1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.panel2,'Visible','off')
set(handles.panel3,'Visible','off')
set(handles.tab1, 'Enable', 'off')
set(handles.tab2, 'Enable', 'on')
set(handles.tab3, 'Enable', 'on')
% Hint: get(hObject,'Value') returns toggle state of tab1


% --- Executes on button press in tab3.
function tab3_Callback(hObject, eventdata, handles)
% hObject    handle to tab3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.panel2,'Visible','on')
set(handles.panel3,'Visible','on')
set(handles.tab1, 'Enable', 'on')
set(handles.tab2, 'Enable', 'on')
set(handles.tab3, 'Enable', 'off')
% Hint: get(hObject,'Value') returns toggle state of tab3


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in setPath.
function setPath_Callback(hObject, eventdata, handles)
% hObject    handle to setPath (see GCBO)
folder_name = uigetdir();
if(folder_name == 0)
    set(handles.path, 'string', pwd);
else
    set(handles.path, 'string', folder_name);
end

get(handles.path,'string')

% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Edit text value in numberRepetitions
function numberRepetitions_Callback(hObject, eventdata, handles)
% hObject    handle to numberRepetitions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = get(handles.numberRepetitions,'String'); 
num_r = str2num(contents)
if(isempty(num_r) || numel(num_r) > 1 || floor(num_r) ~= num_r || num_r <= 0)
    set(handles.warning,'Visible','on')
else
    set(handles.warning,'Visible','off')
end
validate(handles)

% Hints: get(hObject,'String') returns contents of numberRepetitions as text
%        str2double(get(hObject,'String')) returns contents of numberRepetitions as a double


% --- Executes during object creation, after setting all properties.
function numberRepetitions_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numberRepetitions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in solutions.
function solutions_Callback(hObject, eventdata, handles)
% hObject    handle to solutions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
validate (handles)
% Hints: contents = cellstr(get(hObject,'String')) returns solutions contents as cell array
%        contents{get(hObject,'Value')} returns selected item from solutions


% --- Executes during object creation, after setting all properties.
function solutions_CreateFcn(hObject, eventdata, handles)
% hObject    handle to solutions (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in difficulty.
function difficulty_Callback(hObject, eventdata, handles)
% hObject    handle to difficulty (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
switch get(handles.difficulty,'Value')   
  case 6
      %scheme type
      set(handles.horizontal, 'Enable', 'off')
      set(handles.horizontal,'Value',1);
      set(handles.diagonal, 'Enable', 'off')
      set(handles.diagonal,'Value',1);
      set(handles.placeholder, 'Enable', 'off')
      set(handles.placeholder,'Value',1);
      %attribute to vary
      set(handles.figure, 'Enable', 'off')
      set(handles.figure,'Value',1);
      set(handles.shade, 'Enable', 'off')
      set(handles.shade,'Value',1);
      set(handles.rotation, 'Enable', 'off')
      set(handles.rotation,'Value',1);
      set(handles.size, 'Enable', 'off')
      set(handles.size,'Value',1);
      set(handles.border, 'Enable', 'off')
      set(handles.border,'Value',1);
      set(handles.corners, 'Enable', 'off')
      set(handles.corners,'Value',1);
  otherwise
      %scheme type
      set(handles.horizontal, 'Enable', 'on')
      set(handles.diagonal, 'Enable', 'on')
      set(handles.placeholder, 'Enable', 'on')
      %attribute to vary
      set(handles.figure, 'Enable', 'on')
      set(handles.shade, 'Enable', 'on')
      set(handles.rotation, 'Enable', 'on')
      set(handles.size, 'Enable', 'on')
      set(handles.border, 'Enable', 'on')
      set(handles.corners, 'Enable', 'on')
      set(handles.generate,'Enable','off')
end 
validate(handles);
% Hints: contents = cellstr(get(hObject,'String')) returns difficulty contents as cell array
%        contents{get(hObject,'Value')} returns selected item from difficulty

% --- Executes during object creation, after setting all properties.
function difficulty_CreateFcn(hObject, eventdata, handles)
% hObject    handle to difficulty (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in horizontal.
function horizontal_Callback(hObject, eventdata, handles)
% hObject    handle to horizontal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
validate (handles)
% Hint: get(hObject,'Value') returns toggle state of horizontal


% --- Executes on button press in diagonal.
function diagonal_Callback(hObject, eventdata, handles)
% hObject    handle to diagonal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
validate (handles)
% Hint: get(hObject,'Value') returns toggle state of diagonal


% --- Executes on button press in placeholder.
function placeholder_Callback(hObject, eventdata, handles)
% hObject    handle to placeholder (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
validate (handles)
% Hint: get(hObject,'Value') returns toggle state of placeholder


% --- Executes on button press in figure.
function figure_Callback(hObject, eventdata, handles)
% hObject    handle to figure (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
validate (handles)
% Hint: get(hObject,'Value') returns toggle state of figure


% --- Executes on button press in shade.
function shade_Callback(hObject, eventdata, handles)
% hObject    handle to shade (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
validate (handles)
% Hint: get(hObject,'Value') returns toggle state of shade


% --- Executes on button press in rotation.
function rotation_Callback(hObject, eventdata, handles)
% hObject    handle to rotation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
validate (handles)
% Hint: get(hObject,'Value') returns toggle state of rotation


% --- Executes on button press in size.
function size_Callback(hObject, eventdata, handles)
% hObject    handle to size (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
validate (handles)
% Hint: get(hObject,'Value') returns toggle state of size


% --- Executes on button press in border.
function border_Callback(hObject, eventdata, handles)
% hObject    handle to border (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
validate (handles)
% Hint: get(hObject,'Value') returns toggle state of border


% --- Executes on button press in corners.
function corners_Callback(hObject, eventdata, handles)
% hObject    handle to corners (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
validate (handles)
% Hint: get(hObject,'Value') returns toggle state of corners

%%Function to generate 
% --- Executes on button press in generate.
function  generate_Callback(hObject, eventdata, handles)
% hObject    handle to generate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
location = get(handles.path,'String');
contents = get(handles.numberRepetitions,'String'); 
%number of repetitions
num_repetitions = str2num(contents)
content = get(handles.solutions,'String'); 
%number of solutions
num_solutions = str2num(content{get(handles.solutions,'Value')})
content = get(handles.difficulty,'String'); 
%difficulty 
difficulty = str2num(content{get(handles.difficulty,'Value')})
%function to create the folders
directory(location,difficulty,num_solutions);
%first vector for scheme type
schemeValues = [get(handles.horizontal,'value') get(handles.horizontal,'value') get(handles.diagonal,'value') get(handles.diagonal,'value') get(handles.placeholder,'value') get(handles.placeholder,'value')]
%second vector for attribute to vary
attributeValues = [get(handles.figure,'value') get(handles.shade,'value') get(handles.rotation,'value') get(handles.size,'value') get(handles.border,'value') get(handles.corners,'value')]
%solution method
solutionMethod = [get(handles.solMethod,'value')]

assignin('base','location',location)
assignin('base','num_repetitions',num_repetitions)
assignin('base','num_solutions',num_solutions)
assignin('base','difficulty',difficulty)
assignin('base','schemeValues',schemeValues)
assignin('base','attributeValues',attributeValues)
assignin('base','solutionMethod',solutionMethod)
% handles    structure with handles and user data (see GUIDATA)

if solutionMethod==1
 
if difficulty==1
    type1_basic(schemeValues,attributeValues,num_repetitions,num_solutions,location)
elseif difficulty==2
    type2_basic(schemeValues,attributeValues,num_repetitions,num_solutions,location)
elseif difficulty==3
    type3_basic(schemeValues,attributeValues,num_repetitions,num_solutions,location)
elseif difficulty==4
    type4_basic(schemeValues,attributeValues,num_repetitions,num_solutions,location)
elseif difficulty==5
    type5_basic(schemeValues,attributeValues,num_repetitions,num_solutions,location)
elseif difficulty==6
    type6_basic(schemeValues,attributeValues,num_repetitions,num_solutions,location)    
end
 
else
 
if difficulty==1
    type1_muta(schemeValues,attributeValues,num_repetitions,num_solutions,location)
elseif difficulty==2
    type2_muta(schemeValues,attributeValues,num_repetitions,num_solutions,location)
elseif difficulty==3
    type3_muta(schemeValues,attributeValues,num_repetitions,num_solutions,location)
elseif difficulty==4
    type4_muta(schemeValues,attributeValues,num_repetitions,num_solutions,location)
elseif difficulty==5
    type5_muta(schemeValues,attributeValues,num_repetitions,num_solutions,location)
elseif difficulty==6
    type6_muta(schemeValues,attributeValues,num_repetitions,num_solutions,location)    
end
 
end

% --- Executes on button press in step2.
function step2_Callback(hObject, eventdata, handles)
% hObject    handle to step2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in solMethod.
function solMethod_Callback(hObject, eventdata, handles)
% hObject    handle to solMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns solMethod contents as cell array
%        contents{get(hObject,'Value')} returns selected item from solMethod


% --- Executes during object creation, after setting all properties.
function solMethod_CreateFcn(hObject, eventdata, handles)
% hObject    handle to solMethod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in continueButton.
function continueButton_Callback(hObject, eventdata, handles)
% hObject    handle to continueButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.panel0, 'Visible', 'off')

% --- Executes on button press in agreed.
function agreed_Callback(hObject, eventdata, handles)
% hObject    handle to agreed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if (get(handles.agreed,'Value') == 0)
    set(handles.continueButton, 'Enable', 'off')
else
    set(handles.continueButton, 'Enable', 'on')
end
% Hint: get(hObject,'Value') returns toggle state of agreed
