function type1_basic(schemes,chosen_att00,repetition,options,savepath)
close all
set(0,'DefaultFigureVisible','off');

%declare which schemes you want to use; a level difficulty 6 requires at least 5 of them
%we will allow to choose only by groups of 2 in the interface [1 1 -- 1 1 -- 1 1]
scheminator=schemes==1;
%choose the attributes to vary; at least as many as difficulty level (the adjusted one in final version) 
%1. figure
%2. grey shade
%3. rotation
%4. size of the figure
%5. external border type
%6. external corner type
attributer=chosen_att00==1;
allattributes=[1 2 3 4 5 6];
chosen_att=allattributes(attributer);
nochosen_att=allattributes(attributer==0);
Natt=sum(attributer);

%-----------------------------------------------------
% first part of the code computes radii and centers
% for the outer circles 
%-----------------------------------------------------

% shape matrix: first row X, second row Y
shape{1,1}=[1 1 5 5 4 4 2 2;4 5 5 4 4 1 1 4];  % T
shape{2,1}=[1 1 2 2 4 4 5 5 4 4 2 2 ;0 5 5 3 3 4 4 1 1 2 2 0]; % dumbell
%----
shape{3,1}=[2 2 3 3 4 4;1 3 3 2 2 1]; % the L-shape
shape{4,1}=[2 2 5;1 4 1]; % triangle 45-degree
shape{5,1}=[1 1 2 2 4 1;1 4 4 3.5 3.5 1]; % chipped triangle
%---
shape{6,1}=[1 1 2 2 3 3 4 4 ;1 4 4 2 2 4 4 1]; % U
shape{7,1}=[1 1 3.5 3.5 4 4;1 4 4 3.5 3.5 1]; % chipped square
shape{8,1}=[1 1 2 2 3 3 4 4;1 4 4 3.5 3.5 4 4 1]; % mini-lock
shape{9,1}=[1 1 4 2.5 4;1 4 4 2.5 1]; % packman
shape{10,1}=[1 1 4 4 3.225 2.5 1.725; 1 4 4 1 1.725 1 1.725]; % gosht
%----
shape{11,1}=[1 2 5 6;1 3 3 1]; % trapezio
shape{12,1}=[1 1 3 3 4 4 6 6 ;1 3 3 4 4 3 3 1]; % one bin lego
shape{13,1}=[1 1 2 2 3 3 4 4 5 5 6 6;1 3 3 4 4 3 3 4 4 3 3 1]; % plug
shape{14,1}=[1 2 7 8 8 6 6 3 3 1;2 4 4 2 1 1 2 2 1 1]; % coffee table
%----
shape{15,1}=[2 2 1 3 5 4 4;1 4 4 6 4 4 1]; % arrow
shape{16,1}=[1 1 3 5 5 4 4 2 2 ;1 2 4 2 1 1 2 2 1]; % little house
shape{17,1}=[1 1 2 2 3 3 4 4 5 5 6 6 4 4 3 3;5 9 9 6 6 9 9 6 6 9 9 5 5 1 1 5]; % fork
shape{18,1}=[1 1 2 3 3 2 2;1 3 4 4 3 3 1]; % knive
shape_qmark=[2.25 2.25 3 3.5 3.5 3 2.5 2 1.5 1.5 2.25 2.5 3 3.25 3.75 3.9 3.9 3.75 3 3;1 3.5 5 6 7 8 8 7 7 7.5 9 9.25 9.25 9 8 7 6 5 3.5 1]; % question-mark
shape_qpoint=[2.25 2.25 3 3;-1.5 0 0 -1.5]; % question-mark point
% shape{9,1}=[1 1 2 2 1.5 1.5 3.5 3.5 3 3 4 4 ;1 4 4 3.5 3.5 1.5 1.5 3.5 3.5 4 4 1]; % lock
% shape{16,1}=[1 3 4 2;1 4 4 1]; % diagonal
% shape{18,1}=[1 1 2.5 2 2.5 2 2.5 2 2; 1 9 9 8 7 6 5 5 1]; % knive

Ns=size(shape,1);
shapevec=1:Ns;
center=zeros(Ns,2);
radius=zeros(Ns,1);
quad00=zeros(Ns,4,2);
for jj=1:Ns
    minX=min(shape{jj,1}(1,:));
    maxX=max(shape{jj,1}(1,:));
    minY=min(shape{jj,1}(2,:));
    maxY=max(shape{jj,1}(2,:));
    center(jj,1)=(minX+maxX)/2;
    center(jj,2)=(minY+maxY)/2;
    r0=zeros(length(shape{jj,1}(1,:)),1);
    for ii=1:length(shape{jj,1}(1,:))
        r0(ii)=((center(jj,1)-shape{jj,1}(1,ii))^2+(center(jj,2)-shape{jj,1}(1,ii))^2)^.5;
    end
    radius(jj)=max(r0)+1.1;
    quad00(jj,:,1)=[center(jj,1)-radius(jj) center(jj,1)-radius(jj) center(jj,1)+radius(jj) center(jj,1)+radius(jj)];
    quad00(jj,:,2)=[center(jj,2)-radius(jj) center(jj,2)+radius(jj) center(jj,2)+radius(jj) center(jj,2)-radius(jj)];
end

%%
%----------------------------------------
%scond part starts here with the matrices
%----------------------------------------

% aux_att=combinator(6,2,'c'); %to be used later for the compsition of the solution set

for hh=options %12
Nsol=hh; %number of options in solution (4,6,8,10,12 must be even)
Nrep=repetition; %number of repetitons of matrices

torow=Nsol/2;
if Nsol==4; solsize=[250, 250, 605, 318];
elseif Nsol==6; solsize=[250 250 725 320];
elseif Nsol==8; solsize=[250, 250, 700, 420];
elseif Nsol==10; solsize=[250, 250, 875, 430];
else solsize=[250, 250, 1090, 465];
end

schemes=zeros(3,3,6);
schemes(:,:,1)=[1 1 1;2 2 2;3 3 3]; %horizontal
schemes(:,:,2)=[1 2 3;1 2 3;1 2 3]; %vertical
schemes(:,:,3)=[2 3 1;1 2 3;3 1 2]; %counter-diagonal
schemes(:,:,4)=[3 1 2;1 2 3;2 3 1]; %diagonal
schemes(:,:,5)=[1 2 2;3 1 2;3 3 1]; %cholesky
schemes(:,:,6)=[1 1 2;1 2 3;2 3 3]; %counter-cholesky
% schemes(:,:,7)=[1 2 3;3 1 2;1 2 3]; %greater sign
% schemes(:,:,8)=[1 2 3;2 3 1;1 2 3]; %smaller sign
% schemes(:,:,7)=[3 1 2;1 2 3;2 3 1]; %diamond
schemes=schemes(:,:,scheminator);
Nsch=size(schemes,3); %number of schemes

solcheck=zeros(Nsol,6);

rota=[0 90 180 270];
Nr=length(rota);
if Nsol==4; a0=.1;
elseif Nsol==6; a0=.2;
elseif Nsol==8; a0=.4;
elseif Nsol==10; a0=.5;
else a0=.6;
end
titlespace=[0 a0;a0 0;0 -a0;-a0 0];
shade=[0 0 0;120 120 120;200 200 200;255 255 255]/255;
Nc=size(shade,1); %number of colors
zoomy=[.99 .79 .55 .35];
Nz=length(zoomy);
linep={'-';'--'};
linec=[0 0 0;200 200 200]/255; %alternative red [139 71 93]
Nl=size(linep,1)*size(linec,1);
line00=[1 1 0 0;1 0 1 0]+1;
linepw=[1,3,6,12];
markp00={'o';'s';'d';'^';'<';'>';'v'};
Nm=size(markp00,1);
markc=[0 0 0;200 200 200]/255;
mark00=[1 1 0 0;1 0 1 0]+1;

colvec=1:Nc;
solvec=1:Nsol;
zoomvec=1:Nz;
rotavec=1:Nr;
linvec=1:Nl;
markvec=1:Nm;

solname={'A';'B';'C';'D';'E';'F';'G';'H';'I';'J';'K';'L'}; 
sol_list=[]; %keep track of the correct answers
sol_listvectors=zeros(Nsol,6,Nrep); %keep track of the entire solution vectors for each puzzle
sol_rightvectors=zeros(Nrep,6); %keep track of the correct solution vector for each puzzle

for ii=1:Nrep % number of matrices to create
    
pick_2mark=datasample(markvec,2,'Replace',false); 
markp=markp00(pick_2mark);
    
%compose the varying attributes vector
pick_attribute=zeros(1,6);
if Natt==6
pick_attribute=datasample(1:6,6,'Replace',false);  
else
pick_attribute(1,1:Natt)=datasample(chosen_att,Natt,'Replace',false);
pick_attribute(1,Natt+1:end)=datasample(nochosen_att,6-Natt,'Replace',false);
end
pick_schemes=datasample(1:Nsch,1,'Replace',false); %pick one scheme to follow

if pick_attribute(1)==1
attribute1=datasample(shapevec,3,'Replace',false);    
else
attribute1=datasample(1:4,3,'Replace',false);
end

%pick fixed attribute
if pick_attribute(2)==1
attribute2=randi(Ns);   
else
attribute2=randi(4);
end
if pick_attribute(3)==1
attribute3=randi(Ns);    
else
attribute3=randi(4);
end
if pick_attribute(4)==1
attribute4=randi(Ns);     
else
attribute4=randi(4);
end
if pick_attribute(5)==1
attribute5=randi(Ns);  
else
attribute5=randi(4);
end
if pick_attribute(6)==1
attribute6=randi(Ns);  
else
attribute6=randi(4);
end

% matrix
%%%%%%%%
h0=figure;
attribute00=zeros(1,6);
attribute00(pick_attribute(2))=attribute2;
attribute00(pick_attribute(3))=attribute3;
attribute00(pick_attribute(4))=attribute4;
attribute00(pick_attribute(5))=attribute5;
attribute00(pick_attribute(6))=attribute6;
for jj=1:8
    subplot(3,3,jj)
    schemes00=schemes(:,:,pick_schemes(1));
    attribute00(pick_attribute(1))=attribute1(schemes00(jj));
    patch(quad00(attribute00(1),:,1),quad00(attribute00(1),:,2),[1 1 1],'EdgeColor',linec(line00(1,attribute00(5)),:),'LineWidth',3,'LineStyle',...
        linep{line00(2,attribute00(5))},'Marker',markp{mark00(2,attribute00(6))},'MarkerSize',5,'MArkerFaceColor',markc(mark00(1,attribute00(6)),:),'MArkerEdgeColor',markc(mark00(1,attribute00(6)),:))
    patch(shape{attribute00(1),1}(1,:),shape{attribute00(1),1}(2,:),shade(attribute00(2),:),'EdgeColor','black','LineWidth',1)
    camroll(rota(attribute00(3))) % execute the rotation
    camzoom(zoomy(attribute00(4))) % execute zoom
    axis equal
    axis tight
    axis off
end

subplot(3,3,9)
patch(shape_qmark(1,:),shape_qmark(2,:),[0 0 0])
patch(shape_qpoint(1,:),shape_qpoint(2,:),[0 0 0])
% axis equal
camzoom(.6)
axis tight
axis off

name=[savepath '\output\type1_' num2str(Nsol) '\set' num2str(ii)];
set(h0,'PaperPositionMode','auto')
print(name,'-dpdf','-r0')

% answers
%%%%%%%%%
h1=figure('position', solsize);
pick_sol=datasample(solvec,Nsol,'Replace',false);
solvect00=zeros(Nsol,6); %6 is the number of attributes

subplot(2,torow,pick_sol(1))
    schemes00=schemes(:,:,pick_schemes(1));
    attribute00(pick_attribute(1))=attribute1(schemes00(9));
    patch(quad00(attribute00(1),:,1),quad00(attribute00(1),:,2),[1 1 1],'EdgeColor',linec(line00(1,attribute00(5)),:),'LineWidth',3,'LineStyle',...
        linep{line00(2,attribute00(5))},'Marker',markp{mark00(2,attribute00(6))},'MarkerSize',5,'MArkerFaceColor',markc(mark00(1,attribute00(6)),:),'MArkerEdgeColor',markc(mark00(1,attribute00(6)),:))
    patch(shape{attribute00(1),1}(1,:),shape{attribute00(1),1}(2,:),shade(attribute00(2),:),'EdgeColor','black','LineWidth',1)
    camroll(rota(attribute00(3))) % execute the rotation
    camzoom(zoomy(attribute00(4))) % execute zoom
    axis tight
    tith=title(solname(pick_sol(1)));
    v0=get(tith,'Position');
    set(tith,'Position',[v0(1)+titlespace(attribute00(3),1) v0(2)+titlespace(attribute00(3),2) v0(3)]);
    axis off
    
sol_list=[sol_list pick_sol(1)];
sol_listvectors(pick_sol(1),:,ii)=attribute00;
att00=attribute00; % solution attributes vector
sol_rightvectors(ii,:)=att00;
solcheck(1,:)=attribute00;
 %---------------
check00=0;
   
count_att=[1 2 3 4 5 6 1 2 3 4 5 6];
shift=[1 1 1 1 1 1 2 2 2 2 2 2];
for jj=2:Nsol
subplot(2,torow,pick_sol(jj))
    
    attribute00=att00;
    attribute00(pick_attribute(count_att(jj)))=rerandi(pick_attribute(count_att(jj)),att00(pick_attribute(count_att(jj))),shift(jj));
    
    for d_check=1:jj-1
        check0=sum(attribute00==solcheck(d_check,:))==6;
        check00=check00+check0;
    end
    
    if check00>0 %this should not be 0 by construction; check point
        ppp
    end
  %---------------    
    solcheck(jj,:)=attribute00;
    sol_listvectors(pick_sol(jj),:,ii)=attribute00;
    patch(quad00(attribute00(1),:,1),quad00(attribute00(1),:,2),[1 1 1],'EdgeColor',linec(line00(1,attribute00(5)),:),'LineWidth',3,'LineStyle',...
        linep{line00(2,attribute00(5))},'Marker',markp{mark00(2,attribute00(6))},'MarkerSize',5,'MArkerFaceColor',markc(mark00(1,attribute00(6)),:),'MArkerEdgeColor',markc(mark00(1,attribute00(6)),:))
    patch(shape{attribute00(1),1}(1,:),shape{attribute00(1),1}(2,:),shade(attribute00(2),:),'EdgeColor','black','LineWidth',1)
    camroll(rota(attribute00(3))) % execute the rotation
    camzoom(zoomy(attribute00(4))) % execute zoom
    axis tight
    tith=title(solname(pick_sol(jj)));
    v0=get(tith,'Position');
    set(tith,'Position',[v0(1)+titlespace(attribute00(3),1) v0(2)+titlespace(attribute00(3),2) v0(3)]);
%     title(solname(pick_sol(jj)))
    axis off
end
name=[savepath '\output\type1_' num2str(Nsol) '\set' num2str(ii) '_sol'];
set(h1,'PaperPositionMode','auto')
set(h1,'PaperOrientation','landscape')
print(name,'-dpdf','-r0')

close all
end

name=[savepath '\output\type1_' num2str(Nsol) '\type1_' num2str(Nsol) 'asnwerkey.xlsx'];
key=[1:Nrep;sol_list];
xlswrite(name,key')

name=[savepath '\output\type1_' num2str(Nsol) '\type1_' num2str(Nsol) '.mat'];
save(name)
end

set(0,'DefaultFigureVisible','on');
end